# coding=utf-8
#
# Copyright 2016 F5 Networks Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

"""Directory: net module: fdb.

REST URI
    ``https://localhost/mgmt/tm/net/fdb``

GUI Path
    ``XXX``

REST Kind
    ``tm:net:fdb:*``
"""


from f5.bigip.resource import Collection
from f5.bigip.resource import Resource


class Fdbs(Collection):
    '''A Collection concrete subclass docstring.'''
    def __init__(self, net):
        '''Auto generated constructor.'''
        super(Fdbs, self).__init__(net)
        self._meta_data['allowed_lazy_attributes'] = [Tunnels]
        self._meta_data['template_generated'] = True
        self._meta_data['icontrol_version'] = '11.5.0'


class Tunnel(Resource):
    '''A Resource concrete subclass.'''
    def __init__(self, Tunnels):
        '''Autogenerated constructor.'''
        super(Tunnel, self).__init__(Tunnels)
        self._meta_data['template_generated'] = True
        self._meta_data['required_json_kind'] =\
            u"tm:net:fdb:tunnel:tunnelstate"
        self._meta_data['attribute_registry'] = {}
        # Setting this here to be explicit, even though it is set via
        # the super call from its containing object.
        self._meta_data['icontrol_version'] = '11.5.0'


class Tunnels(Collection):
    '''A Collection concrete subclass docstring.'''
    def __init__(self, fdb):
        '''Auto generated constructor.'''
        super(Tunnels, self).__init__(fdb)
        self._meta_data['allowed_lazy_attributes'] = [Tunnel]
        self._meta_data['attribute_registry'] =\
            {u'tm:net:fdb:tunnel:tunnelstate': Tunnel}
        self._meta_data['template_generated'] = True
        # Setting this here to be explicit, even though it is set via
        # the super call from its containing object.
        self._meta_data['icontrol_version'] = '11.5.0'


class Vlans(Collection):
    '''A Collection concrete subclass docstring.'''
    def __init__(self, fdb):
        '''Auto generated constructor.'''
        super(Vlans, self).__init__(fdb)
        # self._meta_data['allowed_lazy_attributes'] = [Vlan]
        # self._meta_data['attribute_registry'] =\
        #     {u'tm:net:fdb:vlan:vlanstate': Vlan}
        self._meta_data['template_generated'] = True
        # Setting this here to be explicit, even though it is set via
        # the super call from its containing.
        self._meta_data['icontrol_version'] = '11.5.0'
